$Client_Post_Command_Handler{'pauserecording'}{'custompauserecording'} = sub { 
    my @allreturn = ();
    my $origen   = shift;
    my $destino  = shift;
    my $contexto = shift;
    my $socket   = shift;

    # print "origen $origen destino $destino contexto $contexto\n";

    my $mychannel      = main::get_btn_config( "$contexto", $origen, 'MAINCHANNEL');
    my $activechannel  = main::get_active_chan($mychannel);
    my $bridgechannel  = main::get_active_link($mychannel);

    if ($bridgechannel =~ m/^Local/i) {
        my $newchan = $canal = FOP2::utils::get_channel($bridgechannel);
        $bridgechannel  = main::get_active_link($newchan);
    }

    # print "my channel $mychannel active $activechannel bridge $bridgechannel\n";

    if ( !main::hasPermChannel( $socket, "monitor", $mychannel ) && !main::hasPerm( $socket, "all" ) ) {
        # No 'dial' permission, abort action
        print "No permissions for pausing the recording. Requires monitor or all.\n";
        return @allreturn;
    }


    # Keep internal track of paused state, so we can iterate between states
    #
    if(defined($main::pluginvariable{'pauserecording'}{'ispaused'}{$mychannel})) {
        $paused = $main::pluginvariable{'pauserecording'}{'ispaused'}{$mychannel};
        print "State pauserecording,ispaused,$mychannel esta definido y tiene valor $paused\n";
    } else {
        $paused = 0;
        print "State pauserecording,ispaused,$mychannel no esta definido y lo inicio con valor $paused\n";
    }

    # Toggle state
    $paused ^= 1;
    
    $main::pluginvariable{'pauserecording'}{'ispaused'}{$mychannel} = $paused;

    # Special construction in ActionID in order to catch the Action response
    # so we can fire a UserEvent in case command succeeds
    #
    my $return = {
        Action    => 'MixMonitorMute',
        Channel   => $bridgechannel,
        State     => $paused,
        Direction => 'both',
        ActionID  => "pausemixmonitor!$bridgechannel!$mychannel!$paused"
    };
    push @allreturn, $return;

    $return = {
        Action    => 'MixMonitorMute',
        Channel   => $activechannel,
        State     => $paused,
        Direction => 'both',
        ActionID  => "pausemixmonitor!$activechannel!$mychannel!$paused"
    };
    push @allreturn, $return;

    # print Dumper @allreturn;
 
    return @allreturn;
};

# Catching a command response
$AMI_Response_Handler{'pauserecording'}{'pausemixmonitor'} = sub { 

     my $response = shift;
     my $extra    = shift;

     my @allreturn;

     my ($aid0, $activechannel, $mychannel, $ispaused)   = split/!/, $extra;

     # print Dumper $response;

     if($response->{Response} eq "Success") {

        # Fire a UserEvent on comand success to notify the client that mixmonitor mute is active or inactive
        
        $main::pluginvariable{'pauserecording'}{'ispaused'}{$mychannel} = 1;
        my $valor = { 'Event' => 'UserEvent', 'UserEvent' => 'PauseMixMonitorComplete', 'Channel' => $mychannel, 'Family' => "pauserecording", 'Value' => $ispaused };
        push @allreturn, $valor;

     }

     return @allreturn;
};

$AMI_Event_Handler{'pauserecording'}{'HANGUP'} = sub {
    my $event = shift;
    my @allreturn;

    my $canal = FOP2::utils::get_channel(${$event}{Channel});
    delete $main::pluginvariable{'pauserecording'}{'ispaused'}{$canal};

    return @allreturn;
};
